#ifndef included
#error This script can only be compiled as a #include
#endif

#ifndef __ATTRIBS_M
#define __ATTRIBS_M

#define INET_HOMEPAGE "http://kameleondui.leechbite.com/home.php"
#define INET_HOMEPAGEROOT "http://kameleondui.leechbite.com/"
//#define INET_HOMEPAGE "http://localhost/kameleondui2/home.php"
//#define INET_HOMEPAGEROOT "http://localhost/kameleondui2/"
#define SKIN_VERSION "00150"

#include <lib/config.mi>

// -----------------------------------------------------------------------------------------------------------------

// this is the page that maps its items to the options menu, you can add attribs or more pages (submenus)
#define CUSTOM_OPTIONSMENU_ITEMS "{1828D28F-78DD-4647-8532-EBA504B8FC04}"

// this is the page that maps its items to the windows menu (aka View), you can add attribs or more pages (submenus)
#define CUSTOM_WINDOWSMENU_ITEMS "{6559CA61-7EB2-4415-A8A9-A2AEEF762B7F}"

// custom options submenu item page, you can add more, just use guidgen and Config.newItem()
#define CUSTOM_PAGE "{26E26319-AECA-4433-B8F1-F4A5BF2A9ED5}"

// windows config page
#define CUSTOM_PAGE_WINDOWS "{5E13F556-4221-4192-BC01-A94059CAD298}"

// notifier config page
#define CUSTOM_PAGE_NOTIFIER "{1AB968B3-8687-4a35-BA70-FCF6D92FB57F}"

// timer config page
#define CUSTOM_PAGE_TIMER "{6AAE5BB1-76AD-49F6-B62D-35AF04F47278}"

// mute mode config page
#define CUSTOM_PAGE_VOLUME "{E2A10AE6-6290-4582-8DBE-6E0CC374445B}"

// wheel control config page
#define CUSTOM_PAGE_WHEEL "{30D2AA12-7052-4517-91EB-34276E0297ED}"

// songticker config page
#define CUSTOM_PAGE_SONGTICKER "{7061FDE0-0E12-11D8-BB41-0050DA442EF3}"

// beat vis control config page
#define CUSTOM_PAGE_BEATVIS "{83FCE54B-7949-48EA-9DA5-5B0A8EE38B80}"

// inet browser config page
#define CUSTOM_PAGE_INETBROWSER "{116EFA85-E078-4C8B-B097-F246A5131521}"

// cd cover config page
#define CUSTOM_PAGE_CDCOVER "{5902D92B-208D-495C-8ED0-0BE3697F4A77}"

// non exposed attribs page
#define CUSTOM_PAGE_NONEXPOSED "{E9C2D926-53CA-400f-9A4D-85E31755A4CF}"


// -----------------------------------------------------------------------------------------------------------------

Function initAttribs();
function boolean onTempText(); // returns TRUE is songticker is still on TempText

// -----------------------------------------------------------------------------------------------------------------



Global ConfigAttribute timer_style_000_00_00_attrib;
Global ConfigAttribute timer_style_000_00_attrib;
Global ConfigAttribute timer_remain_attrib;
Global ConfigAttribute timer_elapsed_attrib;

Global ConfigAttribute notifier_minimized_attrib;
Global ConfigAttribute notifier_windowshade_attrib;
Global ConfigAttribute notifier_always_attrib;
Global ConfigAttribute notifier_never_attrib;
Global ConfigAttribute notifier_fadeintime_attrib;
Global ConfigAttribute notifier_fadeouttime_attrib;
Global ConfigAttribute notifier_holdtime_attrib;
Global ConfigAttribute notifier_disablefullscreen_attrib;
Global ConfigAttribute notifier_showend_attrib;

Global ConfigAttribute notifier_location_topright_attrib;
Global ConfigAttribute notifier_location_topleft_attrib;
Global ConfigAttribute notifier_location_bottomright_attrib;
Global ConfigAttribute notifier_location_bottomleft_attrib;

Global ConfigAttribute notifier_noanim_attrib;
Global ConfigAttribute notifier_anim_fade_attrib;
Global ConfigAttribute notifier_anim_slidevert_attrib;
Global ConfigAttribute notifier_anim_slidehort_attrib;

Global ConfigAttribute notifier_cdcover_attrib;

Global ConfigAttribute bkground_image_attrib;

Global ConfigAttribute attrRepeatAll, attrRepeatTrack;
Global ConfigAttribute attrRepeat, attrShuffle, attrXfade;
Global ConfigAttribute attrXfadeTime;

Global ConfigAttribute vol_mute_attrib;
Global ConfigAttribute vol_attmode_attrib;
Global ConfigAttribute vol_mutemode_attrib;

Global ConfigAttribute wheel_vol_attrib;
Global ConfigAttribute wheel_seek_attrib;
Global ConfigAttribute wheel_bass_attrib;
Global ConfigAttribute wheel_treble_attrib;
Global ConfigAttribute wheel_bal_attrib;

Global ConfigAttribute beat_off_attrib;
Global ConfigAttribute beat_srcVU_attrib;
Global ConfigAttribute beat_srcBass_attrib;
Global ConfigAttribute beat_srcTreble_attrib;

Global ConfigAttribute songticker_scroll_attrib;
Global ConfigAttribute songticker_noscroll_attrib;

Global ConfigAttribute inetbrowser_homepage_attrib;
Global ConfigAttribute inetbrowser_lyrics_luckymode_attrib;
Global ConfigAttribute inetbrowser_chords_luckymode_attrib;
Global ConfigAttribute inetbrowser_info_luckymode_attrib;
Global ConfigAttribute inetbrowser_openpage_attrib;	 // attrib used for outside page request

Global ConfigAttribute cdcover_autodownload_attrib;
Global ConfigAttribute cdcover_getamazoncover_attrib;
Global ConfigAttribute cdcover_size_1x_attrib;
Global ConfigAttribute cdcover_size_full_attrib;
Global ConfigAttribute cdcover_size_custom_attrib;
Global ConfigAttribute cdcover_size_custom_pix_attrib;
Global ConfigAttribute cdcover_aspectratio_attrib;
Global ConfigAttribute cdcover_coverfname_attrib;
Global ConfigAttribute cdcover_mediatype_attrib;
Global ConfigAttribute cdcover_refresh_attrib;
Global ConfigAttribute cdcover_getcdcover_attrib;
Global ConfigAttribute cdcover_menu_attrib;
Global ConfigAttribute cdcover_cdinfo_attrib;
Global ConfigAttribute cdcover_cdstatus_attrib;

Global ConfigAttribute config_custom_solid_attrib;
Global ConfigAttribute config_custom_gradv_attrib;
Global ConfigAttribute config_custom_gradh_attrib;
Global ConfigAttribute config_custom_color1_attrib;
Global ConfigAttribute config_custom_color2_attrib;

Global ConfigAttribute eq_presetname_attrib; // will hold current EQ preset name (e.g. rock, soft etc.)

Global ConfigAttribute temptext_attrib;
Global ConfigAttribute ontemptext_attrib;

Global ConfigAttribute genTimerAttrib;
Global Timer genTimer;


// DUI scripts attributes
Global ConfigItem custom_page_windows; // <-- make this global because its being used by other DUI-scripts..
Global ConfigItem custom_page_nonexposed; // <-- also this.

Global ConfigAttribute windows_duitab_attrib;
Global ConfigAttribute windows_detachonshade_attrib;
Global ConfigAttribute windows_hideshowonresize_attrib;

Global ConfigAttribute windows_pl_attrib;
Global ConfigAttribute windows_ml_attrib;
Global ConfigAttribute windows_vid_attrib;
Global ConfigAttribute windows_avs_attrib;
Global ConfigAttribute windows_eq_attrib;
Global ConfigAttribute windows_cdcover_attrib;
Global ConfigAttribute windows_inet_attrib;
Global ConfigAttribute windows_config_attrib;

Global ConfigAttribute dui_comm_attrib;
Global ConfigAttribute dui_win_main_content_attrib;
Global ConfigAttribute dui_win_main2_content_attrib;
Global ConfigAttribute dui_win_side_content_attrib;
Global ConfigAttribute dui_win_side2_content_attrib;
Global ConfigAttribute dui_last_focus;

Global ConfigAttribute dui_on_focus_attrib;
Global ConfigAttribute dui_checkfocus_attrib;
Global ConfigAttribute dui_on_transition_attrib;
Global ConfigAttribute dui_temp_detach_attrib;
Global ConfigAttribute dui_onresizehide_attrib;
// -----------------------------------------------------------------------------------------------------------------

initAttribs() {

	// create the custom cfgpage for this session (if it does exist, it just returns it)
	ConfigItem custom_page = Config.newItem("KameleonDUI", CUSTOM_PAGE);
	custom_page_windows = Config.newItem("Windows", CUSTOM_PAGE_WINDOWS);
	ConfigItem custom_page_timer = Config.newItem("Timer", CUSTOM_PAGE_TIMER);
	ConfigItem custom_page_volume = Config.newItem("Mute Mode", CUSTOM_PAGE_VOLUME);
	ConfigItem custom_page_wheel = Config.newItem("Wheel Mode", CUSTOM_PAGE_WHEEL);
	ConfigItem custom_page_songticker = Config.newItem("Songticker", CUSTOM_PAGE_SONGTICKER);
	ConfigItem custom_page_beatvis = Config.newItem("Beat Vis", CUSTOM_PAGE_BEATVIS);
	ConfigItem custom_page_inetbrowser = Config.newItem("Internet Browser", CUSTOM_PAGE_INETBROWSER);
	ConfigItem custom_page_cdcover = Config.newItem("CD Cover Art", CUSTOM_PAGE_CDCOVER);
	ConfigItem custom_page_notifier = Config.newItem("Notifications", CUSTOM_PAGE_NOTIFIER);

	custom_page_nonexposed = Config.newItem("Hidden", CUSTOM_PAGE_NONEXPOSED);

	// load up the cfgpage in which we'll insert our custom page
	ConfigItem custom_options_page = Config.getItem(CUSTOM_OPTIONSMENU_ITEMS);
	ConfigItem custom_windows_page = Config.getItem(CUSTOM_WINDOWSMENU_ITEMS);

	// this creates a submenu for this attribute
	ConfigAttribute submenuattrib = custom_options_page.newAttribute("KameleonDUI", "");
	submenuattrib.setData(CUSTOM_PAGE); // discard any default value and point at our custom cfgpage

	ConfigAttribute windowssubmenu = custom_page.newAttribute("Windows", "");
	windowssubmenu.setData(CUSTOM_PAGE_WINDOWS);
	
	ConfigAttribute timersubmenu = custom_page.newAttribute("Timer", "");
	timersubmenu.setData(CUSTOM_PAGE_TIMER);
	
	ConfigAttribute volumesubmenu = custom_page.newAttribute("Mute Mode", "");
	volumesubmenu.setData(CUSTOM_PAGE_VOLUME);
	
	ConfigAttribute wheelsubmenu = custom_page.newAttribute("Wheel Mode", "");
	wheelsubmenu.setData(CUSTOM_PAGE_WHEEL);
	
	ConfigAttribute songtickersubmenu = custom_page.newAttribute("Songticker", "");
	songtickersubmenu.setData(CUSTOM_PAGE_SONGTICKER);

	ConfigAttribute beatvissubmenu = custom_page.newAttribute("Beat Vis", "");
	beatvissubmenu.setData(CUSTOM_PAGE_BEATVIS);
	
	ConfigAttribute inetbrowsersubmenu = custom_page.newAttribute("Internet Browser", "");
	inetbrowsersubmenu.setData(CUSTOM_PAGE_INETBROWSER);
	
	ConfigAttribute cdcoversubmenu = custom_page.newAttribute("CD Cover Art", "");
	cdcoversubmenu.setData(CUSTOM_PAGE_CDCOVER);

	ConfigAttribute notifiersubmenu = custom_page.newAttribute("Notifications", "");
	notifiersubmenu.setData(CUSTOM_PAGE_NOTIFIER);

	ConfigAttribute sep,sep2;

	// default components are pre-defined on initialization. other windows are added later.
	windows_duitab_attrib = custom_page_windows.newAttribute("DUI Tab Mode", "1");
	windows_detachonshade_attrib = custom_page_windows.newAttribute("Detach windows on shade mode", "1");
	windows_hideshowonresize_attrib = custom_page_windows.newAttribute("Hide/Show windows on resize", "1");
	sep = custom_page_windows.newAttribute("sep1", ""); sep.setData("-");
	windows_pl_attrib = custom_page_windows.newAttribute("Attach Playlist Editor window", "1");
	windows_ml_attrib = custom_page_windows.newAttribute("Attach Media Library window", "1");
	windows_vid_attrib = custom_page_windows.newAttribute("Attach Video window", "1");
	windows_avs_attrib = custom_page_windows.newAttribute("Attach Visualizations window", "1");
	windows_eq_attrib = custom_page_windows.newAttribute("Attach Equalizer window", "1");
	windows_cdcover_attrib = custom_page_windows.newAttribute("Attach CD Cover Art window", "1");
	windows_inet_attrib = custom_page_windows.newAttribute("Attach Internet Browser window", "1");
	windows_config_attrib = custom_page_windows.newAttribute("Attach Config Panel window", "1");
	sep = custom_page_windows.newAttribute("sep1", ""); sep.setData("-");
	dui_temp_detach_attrib = custom_page_nonexposed.newAttribute("Temp Detach windows", "0");
	dui_onresizehide_attrib = custom_page_nonexposed.newAttribute("On Resize Hide windows", "0");

	timer_style_000_00_00_attrib = custom_page_timer.newAttribute("000:00:00", "1");
	timer_style_000_00_attrib = custom_page_timer.newAttribute("000:00", "0");
	sep = custom_page_timer.newAttribute("sep1", ""); sep.setData("-");
	timer_remain_attrib = custom_page_timer.newAttribute("Remaining", "0");
	timer_elapsed_attrib = custom_page_timer.newAttribute("Elapsed", "1");	

	vol_attmode_attrib = custom_page_volume.newAttribute("Attenuate", "1");
	vol_mutemode_attrib = custom_page_volume.newAttribute("Mute", "0");
	vol_mute_attrib = custom_page_nonexposed.newAttribute("Volume Mute", "0");

	wheel_vol_attrib = custom_page_wheel.newAttribute("Volume", "1");
	wheel_seek_attrib = custom_page_wheel.newAttribute("Seeker", "0");
	wheel_bass_attrib = custom_page_wheel.newAttribute("Bass", "0");
	wheel_treble_attrib = custom_page_wheel.newAttribute("Treble", "0");
	wheel_bal_attrib = custom_page_wheel.newAttribute("Balance", "0");
	
	songticker_noscroll_attrib = custom_page_songticker.newAttribute("No Scroll", "0");
	songticker_scroll_attrib = custom_page_songticker.newAttribute("Scroll", "1");

	beat_off_attrib = custom_page_beatvis.newAttribute("Off", "0");
	beat_srcVU_attrib = custom_page_beatvis.newAttribute("VU Meter", "1");
	beat_srcBass_attrib = custom_page_beatvis.newAttribute("Bass", "0");
	beat_srcTreble_attrib = custom_page_beatvis.newAttribute("Treble", "0");
	
	inetbrowser_homepage_attrib = custom_page_nonexposed.newAttribute("Inetbrowser Homepage", INET_HOMEPAGE);
	//inetbrowser_lyrics_luckymode_attrib = custom_page_inetbrowser.newAttribute("Lyrics Lucky Search", "1");
	inetbrowser_chords_luckymode_attrib = custom_page_inetbrowser.newAttribute("Chords Lucky Search", "1");
	inetbrowser_info_luckymode_attrib = custom_page_inetbrowser.newAttribute("Artist Info Lucky Search", "1");
	inetbrowser_openpage_attrib = custom_page_nonexposed.newAttribute("Inetbrowser Open Page", "");
	
	cdcover_autodownload_attrib = custom_page_cdcover.newAttribute("Auto-download (Amazon.com)", "1");
	sep = custom_page_cdcover.newAttribute("sep1", ""); sep.setData("-");
	cdcover_size_1x_attrib = custom_page_cdcover.newAttribute("Cover Size: 1x", "0");
	cdcover_size_full_attrib = custom_page_cdcover.newAttribute("Cover Size: Full", "1");
	cdcover_size_custom_attrib = custom_page_cdcover.newAttribute("Cover Size: Custom", "0");
	cdcover_size_custom_pix_attrib = custom_page_nonexposed.newAttribute("CDCover Size Custom Pix", "200");
	cdcover_getamazoncover_attrib = custom_page_nonexposed.newAttribute("CDCover Get Amazon Cover", "0");
	cdcover_aspectratio_attrib = custom_page_nonexposed.newAttribute("CDCover Aspect Ratio", "1.0");
	cdcover_coverfname_attrib = custom_page_nonexposed.newAttribute("CDCover Fname", "");
	cdcover_mediatype_attrib = custom_page_nonexposed.newAttribute("CDCover Media Type", "aud");
	cdcover_refresh_attrib = custom_page_nonexposed.newAttribute("CDCover Refresh", "0");
	cdcover_getcdcover_attrib = custom_page_nonexposed.newAttribute("CDCover Get CD Cover", "0");
	cdcover_menu_attrib = custom_page_nonexposed.newAttribute("CDCover Menu", "0");
	cdcover_cdinfo_attrib = custom_page_nonexposed.newAttribute("CDCover Info", "");
	cdcover_cdstatus_attrib = custom_page_nonexposed.newAttribute("CDCover Status", "");
	
	notifier_always_attrib = custom_page_notifier.newAttribute("Show always", "0");
	notifier_windowshade_attrib = custom_page_notifier.newAttribute("Show with stick, shade and when minimized", "0");
	notifier_minimized_attrib = custom_page_notifier.newAttribute("Show only when minimized", "0");
	notifier_never_attrib = custom_page_notifier.newAttribute("Never show", "1");
	sep = custom_page_notifier.newAttribute("sep1", ""); sep.setData("-");
	notifier_location_topright_attrib = custom_page_notifier.newAttribute("Location: Top Right", "0");
	notifier_location_topleft_attrib = custom_page_notifier.newAttribute("Location: Top Left", "0");
	notifier_location_bottomright_attrib = custom_page_notifier.newAttribute("Location: Bottom Right", "1");
	notifier_location_bottomleft_attrib = custom_page_notifier.newAttribute("Location: Bottom Left", "0");
	sep = custom_page_notifier.newAttribute("sep2", ""); sep.setData("-");
	notifier_noanim_attrib = custom_page_notifier.newAttribute("No Animation", "0");
	notifier_anim_fade_attrib = custom_page_notifier.newAttribute("Anim: Fade", "1");
	notifier_anim_slidevert_attrib = custom_page_notifier.newAttribute("Anim: Vertical Slide", "0");
	notifier_anim_slidehort_attrib = custom_page_notifier.newAttribute("Anim: Horizontal Slide", "0");
	sep = custom_page_notifier.newAttribute("sep3", ""); sep.setData("-");
	notifier_cdcover_attrib = custom_page_notifier.newAttribute("Show CD Cover", "0");
	notifier_disablefullscreen_attrib = custom_page_notifier.newAttribute("Disable in fullscreen", "1");
	notifier_showend_attrib = custom_page_notifier.newAttribute("Show again at end of track", "1");

	notifier_fadeintime_attrib = custom_page_nonexposed.newAttribute("Notifications fade in time", "1000");
	notifier_fadeouttime_attrib = custom_page_nonexposed.newAttribute("Notifications fade out time", "5000");
	notifier_holdtime_attrib = custom_page_nonexposed.newAttribute("Notifications display time", "2000");
	
	bkground_image_attrib = custom_page_nonexposed.newAttribute("Background Image", "RGB:200,200,200;TILE:1");
	
	config_custom_solid_attrib = custom_page_nonexposed.newAttribute("ColorSolid", "1");
	config_custom_gradv_attrib = custom_page_nonexposed.newAttribute("ColorGradV", "1");
	config_custom_gradh_attrib = custom_page_nonexposed.newAttribute("ColorGradH", "1");
	config_custom_color1_attrib = custom_page_nonexposed.newAttribute("ColorColor1", "1");
	config_custom_color2_attrib = custom_page_nonexposed.newAttribute("ColorColor2", "0");

	// *** Other attribs
	
	attrRepeatAll = custom_page_nonexposed.newAttribute("Repeat All", "0");
	attrRepeatTrack = custom_page_nonexposed.newAttribute("Repeat Track", "0");
	configItem item = Config.getItem("Playlist editor");
	attrRepeat = item.getAttribute("repeat");
	attrShuffle = item.getAttribute("shuffle");
	
	item =  Config.getItemByGUID("{FC3EAF78-C66E-4ED2-A0AA-1494DFCC13FF}");
	attrXfade = item.getAttribute("Enable crossfading");
	
	item =  Config.getItemByGUID("{F1239F09-8CC6-4081-8519-C2AE99FCB14C}");
	attrXfadeTime = item.getAttribute("Crossfade time");

	eq_presetname_attrib = custom_page_nonexposed.newAttribute("EQ Preset Name", "CUSTOM");
		
	temptext_attrib = custom_page_nonexposed.newAttribute("Temptext", "");
	ontemptext_attrib = custom_page_nonexposed.newAttribute("onTemptext", "0");
	
	dui_comm_attrib = custom_page_nonexposed.newAttribute("DUIComm", "");
	dui_win_main_content_attrib = custom_page_nonexposed.newAttribute("DUIWinMainContent", "");
	dui_win_main2_content_attrib = custom_page_nonexposed.newAttribute("DUIWinMain2Content", "");
	dui_win_side_content_attrib = custom_page_nonexposed.newAttribute("DUIWinSideContent", "");
	dui_win_side2_content_attrib = custom_page_nonexposed.newAttribute("DUIWinSide2Content", "");
	

	dui_checkfocus_attrib = custom_page_nonexposed.newAttribute("DUICheckFocus", "");
	dui_on_focus_attrib = custom_page_nonexposed.newAttribute("DUIOnFocus", "");

	genTimerAttrib = custom_page_nonexposed.newAttribute("General Timer", "0");
	dui_last_focus = custom_page_nonexposed.newAttribute("Last Focus", "");
	
	dui_on_transition_attrib = custom_page_nonexposed.newAttribute("DUI On Transition", "");
	
	#ifdef MAIN_ATTRIBS_MGR
	
	attrRepeat.onDataChanged();
	
	if (dui_last_focus) dui_last_focus.setData("");
	
	genTimer = new Timer;
	genTimer.setDelay(100);
	genTimer.start();
	
	#endif
	
}

// -----------------------------------------------------------------------------------------------------------------

#define NOOFF if (getData()=="0") { setData("1"); return; }


Global Int attribs_mychange;

// **** the following function def will be redefined "outside" of attribs.m 
// 	and is called whenever an update to certain attribs happens

boolean onTempText() {
  return ontemptext_attrib.getData()=="0";
}

#ifdef MAIN_ATTRIBS_MGR

// **** GENERAL SYNCHRONIZATION TIMER

genTimer.onTimer() {
	int currDat = stringToInteger(genTimerAttrib.getData());

	currDat++;
	if (currDat > 9) currDat = 0;
	
	genTimerAttrib.setData(integerToString(currDat));
}

Global Timer tempTextDelay = NULL;

temptext_attrib.onDataChanged() {
	if (getData()=="") {
		ontemptext_attrib.setData("0");
		return;
	} else {
		if (!tempTextDelay) {
			tempTextDelay = new Timer;
			tempTextDelay.setDelay(3000);
		}
		tempTextDelay.start();
		ontemptext_attrib.setData("1");
	}
}

tempTextDelay.onTimer() {
	stop();
	temptext_attrib.setData("");
}

timer_style_000_00_00_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  timer_style_000_00_attrib.setData("0");

  attribs_mychange = 0;
}

timer_style_000_00_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  timer_style_000_00_00_attrib.setData("0");

  attribs_mychange = 0;
}

timer_remain_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  timer_elapsed_attrib.setData("0");

  attribs_mychange = 0;
}

timer_elapsed_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  timer_remain_attrib.setData("0");

  attribs_mychange = 0;
}

vol_attmode_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  vol_mutemode_attrib.setData("0");

  attribs_mychange = 0;
}

vol_mutemode_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  
  vol_attmode_attrib.setData("0");

  attribs_mychange = 0;
}

// ** notifier attribs **

notifier_always_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_never_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_always_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_minimized_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_windowshade_attrib.setData("0");
  notifier_always_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_windowshade_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_never_attrib.setData("0");
  notifier_always_attrib.setData("0");
  notifier_minimized_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_topleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomright_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_bottomleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_location_bottomleft_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_location_topleft_attrib.setData("0");
  notifier_location_topright_attrib.setData("0");
  notifier_location_bottomright_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_anim_fade_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_anim_slidevert_attrib.setData("0");
  notifier_anim_slidehort_attrib.setData("0");
  notifier_noanim_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_anim_slidevert_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_anim_fade_attrib.setData("0");
  notifier_anim_slidehort_attrib.setData("0");
  notifier_noanim_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_anim_slidehort_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_anim_fade_attrib.setData("0");
  notifier_anim_slidevert_attrib.setData("0");
  notifier_noanim_attrib.setData("0");
  attribs_mychange = 0;
}

notifier_noanim_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;
  notifier_anim_fade_attrib.setData("0");
  notifier_anim_slidevert_attrib.setData("0");
  notifier_anim_slidehort_attrib.setData("0");
  attribs_mychange = 0;
}

// **** repeat attribs *****
attrRepeat.onDataChanged() {
  if (attribs_mychange) return;

  attribs_mychange = 1;
  if (getData()=="1") {
    attrRepeatAll.setData("1");
    attrRepeatTrack.setData("0");
  } else if (getData()=="-1") {
    attrRepeatAll.setData("0");
    attrRepeatTrack.setData("1");
  } else {
    attrRepeatAll.setData("0");
    attrRepeatTrack.setData("0");
  }
  attribs_mychange = 0;

}

attrRepeatAll.onDataChanged() {
  if (attribs_mychange) return;

  //attribs_mychange = 1;
  if (getData()=="1") {
    //attrRepeatTrack.setData("0");
    attrRepeat.setData("1");
  }  else {
    attrRepeat.setData("0");
  }
  //attribs_mychange = 0;
}

attrRepeatTrack.onDataChanged() {
  if (attribs_mychange) return;

  //attribs_mychange = 1;
  if (getData()=="1") {
    //attrRepeatAll.setData("0");
    attrRepeat.setData("-1");
  } else {
    attrRepeat.setData("0");
  }
  //attribs_mychange = 0;
}

wheel_vol_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_seek_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

}

wheel_seek_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_bass_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_seek_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_treble_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_seek_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_bal_attrib.setData("0");

  attribs_mychange = 0;

  
}

wheel_bal_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  wheel_bass_attrib.setData("0");
  wheel_treble_attrib.setData("0");
  wheel_vol_attrib.setData("0");
  wheel_seek_attrib.setData("0");

  attribs_mychange = 0;

  
}

songticker_noscroll_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  songticker_scroll_attrib.setData("0");

  attribs_mychange = 0;
}

songticker_scroll_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  songticker_noscroll_attrib.setData("0");

  attribs_mychange = 0;
}

beat_off_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  beat_srcVU_attrib.setData("0");
  beat_srcBass_attrib.setData("0");
  beat_srcTreble_attrib.setData("0");

  attribs_mychange = 0;

}

beat_srcVU_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  beat_off_attrib.setData("0");
  beat_srcBass_attrib.setData("0");
  beat_srcTreble_attrib.setData("0");

  attribs_mychange = 0;

}

beat_srcBass_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  beat_off_attrib.setData("0");
  beat_srcVU_attrib.setData("0");
  beat_srcTreble_attrib.setData("0");

  attribs_mychange = 0;
  
}

beat_srcTreble_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  beat_off_attrib.setData("0");
  beat_srcBass_attrib.setData("0");
  beat_srcVU_attrib.setData("0");

  attribs_mychange = 0;
  
}

cdcover_size_1x_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  cdcover_size_full_attrib.setData("0");
  cdcover_size_custom_attrib.setData("0");

  attribs_mychange = 0;
  
}

cdcover_size_full_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  cdcover_size_1x_attrib.setData("0");
  cdcover_size_custom_attrib.setData("0");

  attribs_mychange = 0;
  
}

cdcover_size_custom_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  cdcover_size_full_attrib.setData("0");
  cdcover_size_1x_attrib.setData("0");

  attribs_mychange = 0;
  
}

config_custom_solid_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  config_custom_gradv_attrib.setData("0");
  config_custom_gradh_attrib.setData("0");

  attribs_mychange = 0;
}

config_custom_gradv_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  config_custom_solid_attrib.setData("0");
  config_custom_gradh_attrib.setData("0");

  attribs_mychange = 0;
}

config_custom_gradh_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  config_custom_solid_attrib.setData("0");
  config_custom_gradv_attrib.setData("0");

  attribs_mychange = 0;
}

config_custom_color1_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  config_custom_color2_attrib.setData("0");
 
  attribs_mychange = 0;
}

config_custom_color2_attrib.onDataChanged() {
  if (attribs_mychange) return;
  NOOFF
  attribs_mychange = 1;

  config_custom_color1_attrib.setData("0");
 
  attribs_mychange = 0;
}

#endif

#endif
