/*************************************************************

  KameleonDUI - cbutton.m
  by Leechbite

  - this script controls the control buttons (play, pause, etc.)

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global group frameGroup;
Global button play, pause, prev, next, stop, open;

System.onScriptLoaded() {
  initAttribs();
	
  frameGroup = getScriptGroup();
  string param = getParam();

  play = frameGroup.findObject(getToken(param,",",0));
  pause = frameGroup.findObject(getToken(param,",",1));
  prev = frameGroup.findObject(getToken(param,",",2));
  next = frameGroup.findObject(getToken(param,",",3));
  stop = frameGroup.findObject(getToken(param,",",4));
  open = frameGroup.findObject(getToken(param,",",5));

  if (System.getStatus() != 1) {
    Play.show();
    Pause.hide();
  }
  else {
    Pause.show();
    Play.hide();
  }
}

system.onScriptUnloading() {
  return;
}

// ********* play2pause scripts **************

System.onPlay()
{
    Pause.show();
    Play.hide();

}

System.onresume()
{
    Pause.show();
    Play.hide();

}

System.onPause()
{
    Play.show();
    Pause.hide();

}

System.onStop()
{
    Play.show();
    Pause.hide();

}

Next.onLeftClick() {
   setTempText("Next");
}

Prev.onLeftClick() {
   setTempText("Previous");
}