/*************************************************************

  KameleonDUI - cbutton.m
  by Leechbite

  - this script controls the control buttons (play, pause, etc.)

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global group frameGroup;
Global guiObject pstatus;
Global boolean blinkon;

System.onScriptLoaded() {
	initAttribs();
	
	frameGroup = getScriptGroup();
	string param = getParam();

	pstatus = frameGroup.findObject(getToken(param,",",0));

	if (getStatus() == 0) 
		pstatus.hide();
	else
		pstatus.show();
}

system.onScriptUnloading() {
  return;
}

onGenTimer200ms() {
	int currstat = getStatus();
	
	if (currstat == -1) {
		if (!pstatus.isVisible()) pstatus.show();
		blinkon = !blinkon;
		if (blinkon) pstatus.setAlpha(255); else pstatus.setAlpha(5); 	// for some weird reason, using setAlpha(0 or 1) disables/delays
																		// the tool tips.
	}
}

system.onPlay() {
	pstatus.setAlpha(255);
	pstatus.show();
}

system.onResume() {
	pstatus.setAlpha(255);
	pstatus.show();
}

system.onStop() {
	pstatus.hide();
}