/***

Dynamic User Interface v2.0 - DUI-Base.m
by Leechbite

script to control DUI-Base container;

***/

#include <lib/std.mi>
#include "attribs.m"
#include "dui-utilities.m"

Global container duiContainer;

Global group duiWindowMain,duiWindowSide;

Global layout duiLayout, duiBase;
Global guiObject blackBase;

Global boolean onMove = 0;

global timer onStartTimer;

System.onScriptLoaded() {
	
  onStartTimer = new Timer;
  onStartTimer.setDelay(500);
  onStartTimer.start();
	
  duiBase = getContainer("dui.base").getLayout("normal");
  
  blackBase = duiBase.getObject("black.base");
  blackBase.hide();
}

System.onScriptUnloading() {
	delete onStartTimer;
}

onStartTimer.onTimer() {
	stop();
	
	duiContainer = getContainer(MAINID);
	duiLayout = duiContainer.getLayout("normal");
}

duiLayout.onMove() {
	if (onMove) return;
	
	onMove = 1;
	blackBase.show();
}

duiLayout.onEndMove() {
	onMove = 0;
	blackBase.hide();
}