/*************************************************************

  KameleonDUI - centerobject.m
  by Leechbite

  Centers object to parent group.

*************************************************************/

#include <lib/std.mi>
#include "utilities.m"

Global group scriptGroup;
Global guiObject cenObject;
Global boolean notcenterx = FALSE, notcentery = FALSE;

System.onScriptLoaded() {
  scriptGroup = getScriptGroup();
  string param = getParam();

  cenObject = scriptGroup.getObject(getToken(param,",",0));

  notcenterx = (getToken(param,",",1)=="0");
  notcentery = (getToken(param,",",2)=="0");

  scriptGroup.onResize(0,0,0,0);
}

System.onScriptUnloading() {
  return;
}

scriptGroup.onResize(int x, int y, int w, int h) {
  if (cenObject) centerObject(cenObject, !notcenterx, !notcentery);
}

