/*************************************************************

  KameleonDUI - menu-mute.m
  by Leechbite

  Create a right-click activated menu for attenuate/mute selection
  
  param = "objID"

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group scriptGroup;
Global guiObject obj;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
	
	if (objID2 == "")
		obj = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		obj = temp.getObject(objID2); 
	}
	
}

obj.onRightButtonDown(int x, int y) {

	string lasttip = getXMLParam("tooltip");
	obj.setXMLParam("tooltip","");

	popupMenu muteMenu = new popupMenu;

	muteMenu.addCommand("- Mute Mode -", -1, 0, 1);
	muteMenu.addSeparator();
	muteMenu.addCommand(" Attenuate", 0, vol_attmode_attrib.getData()=="1", 0);
	muteMenu.addCommand(" Mute", 1, vol_mutemode_attrib.getData()=="1", 0);
		
	int res = muteMenu.popAtMouse();
	delete muteMenu;
	
	if (res == 0) {
		vol_attmode_attrib.setData("1");
	} else if (res == 1) {
		vol_mutemode_attrib.setData("1");
	}
	
	obj.setXMLParam("tooltip",lasttip);
	
	complete;
}

