/*************************************************************

  KameleonDUI - menu-pl.m
  by Leechbite

  Create a right-click activated menu for quick playlist loading
  
  param = "objID"

*************************************************************/

#include <lib/std.mi>

Global group scriptGroup;
Global guiObject obj;

System.onScriptLoaded() {
	scriptGroup = getScriptGroup();
	string param = getParam();
	
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
	
	if (objID2 == "")
		obj = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		obj = temp.getObject(objID2); 
	}
	
}

obj.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	triggerAction(scriptGroup,"PE_ListOfLists","");
	
	obj.setXMLParam("tooltip",lasttip);
	
	complete;
}

